﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Windows;
using System.Windows.Controls;


namespace MindFusion.Scheduling.Wpf.Samples.CS.ResourceView
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			Contact contact1 = new Contact();
			Contact contact2 = new Contact();
			Contact contact3 = new Contact();

			contact1.FirstName = "Douglas";
			contact1.Id = "CNT38efa514-6c3c-409d-a155-2a01c96bcb22";
			contact1.LastName = "Clark";
			contact2.FirstName = "Jayna";
			contact2.Id = "CNTd467fd8f-a5bc-45c0-a6c3-714a9219ea05";
			contact2.LastName = "Silversteed";
			contact3.FirstName = "Joe";
			contact3.Id = "CNT38d9bb6d-61d2-4140-bc99-3d469abfda74";
			contact3.LastName = "Timberwood";

			this._calendar.ItemContacts.Add(contact1);
			this._calendar.ItemContacts.Add(contact2);
			this._calendar.ItemContacts.Add(contact3);

			// Create some test resources
			Appointment app = null;
			Random r = new Random();

			for (int i = 0; i < 20; i++)
			{
				app = new Appointment();
				app.StartTime = _calendar.Date + TimeSpan.FromDays(r.Next(10) + 3);
				app.EndTime = app.StartTime + TimeSpan.FromHours(24 + r.Next(24));
				app.HeaderText = "Resource " + i.ToString();
				app.Contacts.Add(_calendar.ItemContacts[r.Next(3)]);
				_calendar.Schedule.Items.Add(app);
			}
		}

		private void _calendar_DateClick(object sender, ResourceDateEventArgs e)
		{
			if (e.Clicks == 2 && e.LeftButton == System.Windows.Input.MouseButtonState.Pressed)
			{
				_calendar.ResetDrag();

				Contact c = e.Resource as Contact;
				if (c == null)
					return;

				ResourceWindow form = new ResourceWindow(_calendar, null);

				form.Set(e.Date, c);

				form.ShowDialog();
			}
		}

		private void _calendar_ItemClick(object sender, ItemMouseEventArgs e)
		{
			if (e.Clicks == 2 && e.LeftButton == System.Windows.Input.MouseButtonState.Pressed)
			{
				_calendar.ResetDrag();

				ResourceWindow form = new ResourceWindow(_calendar, e.Item);

				form.ShowDialog();
			}
		}
	}
}
